#!/usr/local/bin/perl

$SD_STOP = 1;
$SD_DOWN = 2;
$SD_DIAG = 3;
$SD_LEFT = 4;

$|=1;
$prwrong = 0 ;
$todo='s';
$cmFlag = 0;
$pr = 1;
$pass = 0;
$DontCare=$transFile='';
$srt=1;
$twolines=0;
$RecInput=0;
$loop=0;
undef($threshold);

while(defined($_=$ARGV[0])&&/^-/) {
	shift;
	if(/^--$/) {
		last;
	} elsif(/^-2/) {
		$twolines = (m/r/) ? 2 : 1;
	} elsif(/^-cm$/) {
		$cmFlag = 1;
	} elsif(/^-e$/) {
		$pr = 0;
		$prwrong = 1;
	} elsif(/^-nosort$/) {
		$srt = 0;
	} elsif(/^-p$/) {
		$pass = 1;
	} elsif(/^-q$/) {
		$pr = 0;
	} elsif(/^-rec$/) {
		$RecInput = 1;
	} elsif(/^-rm(.*)$/) {
		$DontCare = ($1 eq '') ? '@\S*' : $1;
	} elsif(/^-sort$/) {
		$srt = 1;
	} elsif(/^-t$/) {
		$threshold=shift(ARGV);
	} elsif(/^-w$/) {
		$wgtFile=shift(ARGV);
	} elsif(/^-m$/) {
		$todo=shift(ARGV);
	} elsif(/^-trans$/) {
		$transFile=shift(ARGV);
	} elsif(/^-mkpfx$/) {
		$mkpfx=shift(ARGV);
		$mkpfx =~ s/(\W)/\\$1/g;
	} else {
		printf(STDERR "%s: Invalid switch %s\n", $0, $_);
	}
}

if($wgtFile) { &loadWgts($wgtFile, *wgts); }
($transFile) && &transListFromFile(0, $transFile, *transList);

# Read the parallel file "goldtags.txt" of gold standard NER tags into a dynamically sized 2-dimension array
my @goldtaglist = ();
open(GOLDTAGS, "< goldtags.txt") or die "Impossibile aprire il file goldtags.txt";
while(<GOLDTAGS>) { push @goldtaglist, [ split ]; }
close(GOLDTAGS);

# Do the same for the NER tags from the test set
my @testtaglist = ();
open(TESTTAGS, "< testtags.txt") or die "Impossibile aprire il file testtags.txt";
while(<TESTTAGS>) { push @testtaglist, [ split ]; }
close(TESTTAGS);


$StrN=$SErrN=$UnitN=$Sub=$Del=$Ins=0;
$worstUA=$worstPC=100;
$worstStringId=$StringId='';
while($_=<STDIN>) {
	$_=~s/\r?\n$//; # bastardo dos
	if($RecInput) {
		$m=/(.*) *\((.*)\) \| E= *(\d+) S= *(\d+) I= *(\d+) D= *(\d+)/o;
		next unless $m;
		($rec, $correct, $ferr, $fsub, $fins, $fdel)
			= ($1, $2, $3, $4, $5, $6);
		$rec =~ s/^\s*\[[0-9.eE+-]+\]\s+//o;
	} elsif($twolines) {
		if(m/^StringId:\s*(.*)$/) {
			$StringId = $1;
			next;
		}
		$rec = $_;
		if(!($_=<STDIN>)) {
			printf(STDERR "$: unexpected end of file\n");
			last;
		}
		$correct=$_;
		$correct=~s/\r?\n$//; # bastardo dos
		
		if($twolines==2) {
			$tmp = $correct;
			$correct = $rec;
			$rec = $tmp;
		}
	} else {
		if(!m/(.*)\s*\((.*)\)/o) {
			$pass && print $_."\n";
			next;
		}
		$rec = $1;
		$correct = $2;
	}
	if($DontCare ne '') {
		$correct =~ s/$DontCare//og;
		$rec =~ s/$DontCare//og;
	}
	$rec =~ s/^\s+|\s+$//og;
	$rec =~ s/\s+/ /og;
	if(defined($mkpfx)) {
		@seglist = @reclist = ();
		foreach (split(' ', $rec)) {
			if(m/^$mkpfx(\d+)$mkpfx$/o) {
				push(seglist, $1);
			} else {
				push(reclist, $_);
			}
		}
		$rec = join(' ', @reclist);
	} else {
		@reclist = split(' ', $rec);
	}
	$correct =~ s/^\s+|\s+$//og;
	$correct =~ s/\s+/ /og;
	@unitlist = split(' ', $correct);
	if(%transList) {
		&translate(*transList, *reclist);
		&translate(*transList, *unitlist);
		$rec = join(' ', @reclist);
		$correct = join(' ', @unitlist);
	}
	if($pr) {
		length($StringId) && printf("StringId: %s \n", $StringId);
		printf("%s \n", $correct);
		printf("%s \n", $rec);
	}
	$UnitN += $unitN = $#unitlist+1;
	$runitN=$#reclist+1;
	++$StrN;
	@cmp = @path = ();
	$pr && $RecInput
	    && printf("%d %d %d %d -- ", $ferr, $fsub, $fins, $fdel);
	if(%wgts) {
		($sub, $ins, $del, $err, $dist) =
			&strwDiff(*unitlist, *reclist, 's', *wgts, *path);
		&path2cmp(*path, *unitlist, *reclist, *seglist, *cmp);
		printf("%f WEIGHTS \n", $dist);
		next;
	} else {	if ($loop==0) { $loop=1; } else { printf("\n"); }
		if($todo =~ m/s/) {
			($sub, $ins, $del, $err) =
				&strDiff(*unitlist, *reclist, 's', *path);
			&path2cmp(*path, *unitlist, *reclist, *seglist,	*cmp);
#			print "TODO2\n";
#			for(@cmp) { printf("cmp: %s ", $_); }
#			for(@path) { printf("path: %s ", $_); }
			$pr && printf("s: %d %d %d %d -- ",
				      $err, $sub, $ins, $del);
		}
		if($todo =~ m/i/) {
			($sub, $ins, $del, $err) =
				&strDiff(*unitlist, *reclist, 'i', *path);
			&path2cmp(*path, *unitlist, *reclist, *seglist, *cmp);
			$pr && printf("i: %d %d %d %d -- ",
				      $err, $sub, $ins, $del);
		}
		if($todo =~ m/d/) {
			($sub, $ins, $del, $err) =
				&strDiff(*unitlist, *reclist, 'd', *path);
			&path2cmp(*path, *unitlist, *reclist, *seglist, *cmp);
			$pr && printf("d: %d %d %d %d ", $err, $sub, $ins, $del);
		}
	}
	$pr && printf("\n\n");
# il print che segue e' dove stampa i token allineati
	for(@cmp) { printf("%s\n", $_); }
	$le = $sub+$ins+$del;
	$lua = $unitN ? 100*(1-$le/$unitN) : $runitN ? -1000 : 1;
	$lpc = $unitN ? 100*(1-($sub+$del)/$unitN) : 0;
	if($lua<$worstUA) {
		$worstRec = $rec;
		$worstCorrect = $correct;
		$worstUA = $lua;
		$worstPC = $lpc;
		$worstIdx = $StrN;
		$worstStringId = $StringId;
	}
	$Sub += $sub;
	$Ins += $ins;
	$Del += $del;
	$SErrN += ($le>0);
	$UErrN = $Sub+$Del+$Ins;
	if($pr||($prwrong&&$err>0)||(defined($threshold)&&$lua<$threshold)) {
		if(!$pr) {
			length($StringId)
				&& printf("StringId: %s \n", $StringId);
#			printf("%s manu11\n", $correct);
#			printf("%s manu12\n", $rec);
		}
#		printf("str: %5d, u: %5d ", $StrN, $unitN);
#		printf("ua: %6.2f pc: %6.2f ", $lua, $lpc);
#		printf("e: %5d s: %5d i: %5d d: %5d ", $le, $sub, $ins, $del);
#		printf("manu13\n");
#		printf("str: %5d, U: %5d ", $StrN, $UnitN);
#		printf("UA: %6.2f PC: %6.2f ",
#			$UnitN ? 100*(1-$UErrN/$UnitN) : 0,
#			$UnitN ? 100*(1-($Sub+$Del)/$UnitN) : 0);
#		printf("E: %5d S: %5d I: %5d D: %5d ",$UErrN,$Sub,$Ins,$Del);
#		printf("manu14\n\n");
	}
}

if($cmFlag) {
	$hdrl = &hdrlen(*confMat);
	$linefrm="%-".$hdrl."s : %6d %6d %6d %6d %6d %6.1f  %6.1f  | %s \n";
	printf("Summary:manu15\n\n");
	printf("%-".$hdrl."s   %6s %6s %6s %6s %6s %6s %6s manu16\n",
	       "", "sub", "ins", "del", "num", "corr", " %acc ", " %corr ");
	$_k1 = '';
	@row = ();
	@k=sort(keys(%confMat));
	foreach $key (@k) {
		($k1, $k2) = split(' ', $key);
		if($k1 ne $_k1) {
			if(@row) {
				$ins = $confMat{'!NO! '.$_k1};
				$del = $confMat{$_k1.' !NO!'};
				if($srt) { @row = sort ecmp @row; }
				printf($linefrm, $_k1, $sub, $ins, $del, $occ,
				       $occ-($sub+$del),
				       $occ ? 100*(1-($sub+$ins+$del)/$occ):0,
				       $occ ? 100*(1-($sub+$del)/$occ):0,
				       join(', ', @row));
				@row = ();
			}
			$del=$sub=$occ=0;
			$_k1 = $k1;
		}
		$occ += $confMat{$key};
		push(row, sprintf("%s %d manu17", $k2, $confMat{$key}));
		if(($k2 ne '!NO!') && ($k1 ne $k2)) {
			$sub += $confMat{$key};
		}
	}
	if(@row) {
		$ins = $confMat{'!NO! '.$_k1};
		$del = $confMat{$_k1.' !NO!'};
		if($srt) { @row = sort ecmp @row; }
		printf($linefrm, $_k1, $sub, $ins, $del, $occ,
		       $occ-($sub+$del),
		       $occ ? 100*(1-($sub+$ins+$del)/$occ):0,
		       $occ ? 100*(1-($sub+$del)/$occ):0,
		       join(', ', @row));
	}
}

&report if($UnitN>0);

exit(0);

sub strDiff
{
	local(	*Template,
		*Test,
		$mode,
		*path) = @_;
	local(	@Back,
		@Col0,
		@Col1,
		@m0,
		@m1,
		$i,
		$j,
		$_c,
		$_dir,
		$colN,
		$TempLen,
		$Testlen,
		$c,
		$d,
		$sub,
		$ins,
		$del);

#
# m0 e m1 sono usati per privilegiare, **a parita` di punteggio**,
# i cammini che contengono il maggior numero di unita` corrette
#
	if($mode !~ m/^[sdi]$/o) {
		printf(STDERR "strDiff(): invalid mode %s\n", $mode);
		exit(1);
	}
	$TestLen=$#Test+1;
	$TempLen=$#Template+1;
	$colN = $TempLen+1;
	$back[0*$colN+0] = $SD_STOP;
	$Col0[0] = 0;
	$m0[0] = $m1[0] = 0;
	for($j=1; $j<=$TempLen; $j++) {
		$Col0[$j] = $j;
		$m0[$j] = 0;
		$back[0*$colN+$j] = $SD_DOWN;
	}
	for($i=1; $i<=$TestLen; $i++) {
		$Col1[0] = $i;
		$back[$i*$colN+0] = $SD_LEFT;
		for($j=1; $j<=$TempLen; $j++) {
			$d = $Test[$i-1] ne $Template[$j-1];
			$_c = $Col0[$j-1]+$d;
			$_dir = $SD_DIAG;
			$m1[$j] = $m0[$j-1]+!$d;
			if(($c=$Col0[$j]+1)<
			   $_c+(($mode eq 'i')||$m1[$j]<$m0[$j])) {
				$_c = $c;
				$m1[$j] = $m0[$j];
				$_dir = $SD_LEFT;	# ins
			}
			if(($c=$Col1[$j-1]+1)<
			   $_c+(($mode eq 'd')||$m1[$j]<$m1[$j-1])) {
				$_c = $c;
				$m1[$j] = $m1[$j-1];
				$_dir = $SD_DOWN;	# del
			}
			$Col1[$j] = $_c;
			$back[$i*$colN+$j] = $_dir;
		}
		@Col0 = @Col1;
		@m0 = @m1;
	}
	&backtrack(*back, $TempLen, $TestLen, *path);
}

sub backtrack
{
	local(	*back,
		$TempLen,
		$TestLen,
		*path) = @_;
	local(	$sub,
		$del,
		$ins,
		$i,
		$j,
		$c,
		$colN);

	$colN = $TempLen+1;
	$sub = $del = $ins = 0;
	@path = ();
	for($i=$TestLen, $j=$TempLen;$i||$j;) {
		$c = $back[$i*$colN+$j];
		unshift(@path, $i.' '.$j.' '.$c);
		if($c==$SD_STOP) {
			last;
		} elsif($c==$SD_LEFT) {
			++$ins;
			--$i;
			$cmFlag && ++$confMat{'!NO! '.$Test[$i]};
		} elsif($c==$SD_DOWN) {
			++$del;
			--$j;
			$cmFlag && ++$confMat{$Template[$j].' !NO!'};
		} elsif($c==$SD_DIAG) {
			--$i;
			--$j;
			if($Test[$i] ne $Template[$j]) {
				++$sub;
			}
			$cmFlag && ++$confMat{$Template[$j].' '.$Test[$i]};
		} else {
			printf(STDERR "Invalid backpointer!\n");
			exit(1);
		}
	}
	($sub, $ins, $del, $ins+$sub+$del);
}

sub path2cmp
{
	local(	*path,
		*Template,
		*Test,
		*Seg,
		*cmp) = @_;
	local(	$i,
		$j,
		$n,
		$c,
		$line);

	$n = 0;
                $line = $StrN-1;
	for(@path) {
		# The side effect here is to print out the alignment of words and tags, sent to STDOUT
		# This loop is executed once for every word
		($i, $j, $c) = split(' ');
		if($c==$SD_LEFT) {
			$i--;
			# Print the alignment if there was an INSERT (gold tag is always "O", test tag is the original test tag)
			$cmp[$n].=sprintf("%s\tO\tI\t%s\t$testtaglist[$line][$i]","",$Test[$i]);
			if(defined(@Seg)) {
				$cmp[$n] .= ' ('.$Seg[$i].','.$Seg[$i+1].')';
			}
		} elsif($c==$SD_DOWN) {
			$j--;
			# Print the alignment if there was a DELETE (gold tag is the original gold tag, test tag is always "O")
			$cmp[$n].=sprintf("%s\t$goldtaglist[$line][$j]\tD\t%s\tO",$Template[$j],"");
		} elsif($c==$SD_DIAG) {
			if($Template[--$j] eq $Test[--$i]) {
				# Print the alignment if the words were identical (both tags are the original tags)
				$cmp[$n] .=  sprintf("%s\t$goldtaglist[$line][$j]\t\t%s\t$testtaglist[$line][$i]", $Template[$j], $Test[$i]);
			} else {
				# Print the alignment if there was a SUBSTITUTION (both tags are the original tags)
				$cmp[$n] .= sprintf("%s\t$goldtaglist[$line][$j]\tS\t%s\t$testtaglist[$line][$i]", $Template[$j], $Test[$i]);
			}
			if(defined(@Seg)) {
				$cmp[$n] .= ' ('.$Seg[$i].','.$Seg[$i+1].')';
			}
		}
		++$n;
	}
}

sub strwDiff
{
	local(	*Template,
		*Test,
		$mode,
		*wgts,
		*path) = @_;
	local(	@Back,
		@Col0,
		@Col1,
		$i,
		$j,
		$d,
		$_c,
		$_dir,
		$colN,
		$TempLen,
		$Testlen,
		$c,
		$sub,
		$ins,
		$del,
		$tst,
		$tpl);

	if($mode !~ m/^[sdi]$/o) {
		printf(STDERR "strwDiff(): invalid mode %s\n", $mode);
		exit(1);
	}
	$TestLen=$#Test+1;
	$TempLen=$#Template+1;
	$colN = $TempLen+1;
	$back[0*$colN+0] = $SD_STOP;
	$Col0[0] = 0;
	for($j=1; $j<=$TempLen; $j++) {
		$Col0[$j] = $j;
		$back[0*$colN+$j] = $SD_DOWN;
	}
	for($i=1; $i<=$TestLen; $i++) {
		$Col1[0] = $i;
		$back[$i*$colN+0] = $SD_LEFT;
		$tst = $Test[$i-1];
		for($j=1; $j<=$TempLen; $j++) {
			$tpl=$Template[$j-1];
			if($d=($tst ne $tpl)) {
				$w = ($tst le $tpl)
				     ? $wgts{$tpl.' '.$tst}
				     : $wgts{$tst.' '.$tpl};
				defined($w) && ($d=$w);
				# printf(STDERR "d(%s,%s)=%s\n",$tpl,$tst,$d);
			}
			$_c = $Col0[$j-1]+$d;
			$_dir = $SD_DIAG;
			if(($c=$Col0[$j]+1) < $_c+($mode eq 'i')) {
				$_c = $c;
				$_dir = $SD_LEFT;	# ins
			}
			if(($c=$Col1[$j-1]+1) < $_c+($mode eq 'd')) {
				$_c = $c;
				$_dir = $SD_DOWN;	# del
			}
			$Col1[$j] = $_c;
			$back[$i*$colN+$j] = $_dir;
		}
		@Col0 = @Col1;
	}
	$_c = $Col0[$TempLen];
	(&backtrack(*back, $TempLen, $TestLen, *path), $_c);
}

sub ecmp
{
	local(	$ua,
		$ub,
		$na,
		$nb
	);

	($ua, $na) = split(' ', $a, 2);
	($ub, $nb) = split(' ', $b, 2);
	($nb <=> $na) || ($ua cmp $ub);
}

sub hdrlen
{
	local(	*cm) = @_;
	local(	$key,
		$u,
		$l,
		$_l
	);

	$_l = 0;
	foreach $key (keys(%cm)) {
		$u = (split(' ', $key))[0];
		if(($l=length($u))>$_l) {
		 	$_l = $l;
		}
	}
	$_l;
}

sub report
{
#	printf("\n%s %5.2f %% [ %d %s %d ] \n",
#		"String Recognition Rate:",
#		100.*($StrN-$SErrN)/$StrN,
#		$SErrN,
#		"wrong strings out of",
#		$StrN);
	printf("%s %5.2f %%, %s %5.2f %% \n",
		"Unit Accuracy:", 100.*($UnitN-$UErrN)/$UnitN,
		"Percent Correct:", 100.*($UnitN-$Del-$Sub)/$UnitN);
	printf("%s %d, %s %d, %s %d, %s %d, %s %d, %s %d \n\n",
		"Units:", $UnitN,
		"Correct:", ($UnitN-$Del-$Sub),
		"Errors:", $UErrN,
		"Del:", $Del,
		"Ins:", $Ins,
		"Sub:", $Sub);
#	if($worstUA<100) {
#		printf("Worst string (%d: ua=%6.2f pc=%6.2f): \n",
#			$worstIdx, $worstUA, $worstPC);
#		length($worstStringId)
#			&& printf("StringId: %s \n", $worstStringId);
#		printf("%s \n%s \n", $worstCorrect, $worstRec);
#	}
}

sub loadWgts
{
	local($wgtFile, *wgts) = @_;

	if(!open(IN, "<".$wgtFile)) {
		printf(STDERR "Unable to open %s as input\n", $wgtFile);
		exit(1);
	}
	while($_=<IN>) {
		($u0, $u1, $w) = split;
		if($u0 le $u1) {
			$wgts{$u1.' '.$u0} = $w;
		} else {
			$wgts{$u0.' '.$u1} = $w;
		}
	}
	close(IN);
}

sub transListFromFile
{
	local(	$ic,
		$FileName,
		*transList
	) = @_;

	if($FileName =~ m/.gz$/) {
		$FileName = "gzip -dc ".$FileName."|";
	}
	if(!open(IN, $FileName)) {
		printf(STDERR "$0: Unable to open \"%s\"\n",
		       $FileName);
		exit(1);
	}
	while($_=<IN>) {
		$_=~s/\r?\n$//; # bastardo dos
		@F = split(' ', $_, 2);
		($ic) && ($F[0]=~tr/A-Z/a-z/);
		if(!defined($transList{$F[0]})) {
			$transList{$F[0]} = ($#F>0) ? $F[1] : "";
		}
	}
	close(IN);
}

sub translate
{
	local(	*transList,
		*list) = @_;

	foreach(@list) {
		defined($transList{$_}) && ($_=$transList{$_});
	}
	@list = split(' ', join(' ', @list));
}

